VTK: vtkDataSetAttributesFieldList Class Reference

| VTK 9.3.1

Public Member Functions | Protected Member Functions | List of all members
vtkDataSetAttributesFieldList Class Reference

helps manage arrays from multiple vtkDataSetAttributes. More...

`#include <vtkDataSetAttributesFieldList.h>`

## Public Member Functions
| vtkDataSetAttributesFieldList (int number_of_inputs=0)
| `number_of_inputs` parameter is not required and only provided for backwards compatibility. More...
virtual | ~vtkDataSetAttributesFieldList ()
void | PrintSelf (ostream &os, vtkIndent indent)
void | Reset ()
| Initializes the field list to empty. More...
void | InitializeFieldList (vtkDataSetAttributes *dsa)
| Initialize the field list. More...
void | IntersectFieldList (vtkDataSetAttributes *dsa)
| Update the field list for an intersection of arrays registered so far and those in `dsa`. More...
void | UnionFieldList (vtkDataSetAttributes *dsa)
| Update the field list for an union of arrays registered so far and those in `dsa`. More...
void | TransformData (int inputIndex, vtkDataSetAttributes *input, vtkDataSetAttributes *output, std::function< void(vtkAbstractArray *, vtkAbstractArray *)> op) const
| Use this method to provide a custom callback function to invoke for each array in the input and corresponding array in the output. More...
int | GetNumberOfArrays ()
| This method can be used to determine the number of arrays remaining after intersection or union operations. More...
void | BuildPrototype (vtkDataSetAttributes *protoDSA, vtkDataSetAttributes *ordering=nullptr)
| A convenience function that builds a prototype / template dataset attributes for initializing the process of attribute interpolation and copying. More...
void | CopyAllocate (vtkDataSetAttributes *output, int ctype, vtkIdType sz, vtkIdType ext) const
| These methods can called to generate and update the output vtkDataSetAttributes. More...
void | CopyData (int inputIndex, vtkDataSetAttributes *input, vtkIdType fromId, vtkDataSetAttributes *output, vtkIdType toId) const
| These methods can called to generate and update the output vtkDataSetAttributes. More...
void | CopyData (int inputIndex, vtkDataSetAttributes *input, vtkIdType inputStart, vtkIdType numValues, vtkDataSetAttributes *output, vtkIdType outStart) const
| These methods can called to generate and update the output vtkDataSetAttributes. More...
void | InterpolatePoint (int inputIndex, vtkDataSetAttributes *input, vtkIdList *inputIds, double *weights, vtkDataSetAttributes *output, vtkIdType toId) const
| These methods can called to generate and update the output vtkDataSetAttributes. More...

## Protected Member Functions
virtual vtkSmartPointer< vtkAbstractArray > | CreateArray (int type) const
| Called to create an output array for the given type. More...

## Detailed Description

helps manage arrays from multiple vtkDataSetAttributes.

vtkDataSetAttributesFieldList, also called vtkDataSetAttributes::FieldList, is used to help with filters when dealing with arrays from multiple vtkDataSetAttributes instances, potentially from multiple inputs.

Consider a filter that appends multiple inputs, e.g. vtkAppendPolyData. Besides appending mesh elements, such a filter also needs to combine field arrays (point, and cell data) from inputs to pass on to the output. Now if all the inputs had exactly the same set of arrays, we're all set. However, more often than not, the inputs will have different sets of arrays. The filter will need to match up from various inputs to combine together, potentially dropping arrays not in all inputs. Furthermore, it needs to ensure arrays in the output are flagged as attributes consistently. All of this can be done using vtkDataSetAttributesFieldList.

# Usage

Typical usage is as follows:

1. call `IntersectFieldList` or `UnionFieldList` for all input vtkDataSetAttributes instances,
2. allocate arrays for the output vtkDataSetAttributes by using `CopyAllocate`,
3. call `CopyData` per input (preserving the input order used in step 1) to copy tuple(s) from input to the output.

`vtkDataSetAttributes::InitializeFieldList` is provided for API compatibility with previous implementation of this class and it not required to be called. Simply calling `UnionFieldList` or `IntersectFieldList` for the first vtkDataSetAttributes instance is sufficient.

`CopyAllocate,`CopyData`, and`InterpolatePoint` methods on this class are called by similarly named variants on vtkDataSetAttributes that take in a FieldList instance as an argument. Hence, either forms may be used.

Calls to `UnionFieldList` and `IntersectFieldList` cannot be mixed. Use `Reset` or `InitializeFieldList` to change mode and start reinitialization.

Definition at line 58 of file vtkDataSetAttributesFieldList.h.

## Constructor & Destructor Documentation

## ◆ vtkDataSetAttributesFieldList()

vtkDataSetAttributesFieldList::vtkDataSetAttributesFieldList | ( | int | number_of_inputs = `0` | ) |

`number_of_inputs` parameter is not required and only provided for backwards compatibility.

## ◆ ~vtkDataSetAttributesFieldList()

virtual vtkDataSetAttributesFieldList::~vtkDataSetAttributesFieldList | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ PrintSelf()

void vtkDataSetAttributesFieldList::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |

## ◆ Reset()

void vtkDataSetAttributesFieldList::Reset | ( |  | ) |

Initializes the field list to empty.

## ◆ InitializeFieldList()

void vtkDataSetAttributesFieldList::InitializeFieldList | ( | vtkDataSetAttributes * | dsa | ) |

Initialize the field list.

This also adds the first input. Calling this method is optional. The first call to `IntersectFieldList` or `UnionFieldList` on a new instance or after calling `Reset()` will have the same effect.

## ◆ IntersectFieldList()

void vtkDataSetAttributesFieldList::IntersectFieldList | ( | vtkDataSetAttributes * | dsa | ) |

Update the field list for an intersection of arrays registered so far and those in `dsa`.

## ◆ UnionFieldList()

void vtkDataSetAttributesFieldList::UnionFieldList | ( | vtkDataSetAttributes * | dsa | ) |

Update the field list for an union of arrays registered so far and those in `dsa`.

## ◆ CopyAllocate()

void vtkDataSetAttributesFieldList::CopyAllocate | ( | vtkDataSetAttributes * | output,
|  | int | ctype,
|  | vtkIdType | sz,
|  | vtkIdType | ext
| ) |  | const

These methods can called to generate and update the output vtkDataSetAttributes.

These match corresponding API on vtkDataSetAttributes and can be called via the output vtkDataSetAttributes instance instead as well.

## ◆ CopyData() [1/2]

void vtkDataSetAttributesFieldList::CopyData | ( | int | inputIndex,
|  | vtkDataSetAttributes * | input,
|  | vtkIdType | fromId,
|  | vtkDataSetAttributes * | output,
|  | vtkIdType | toId
| ) |  | const

These methods can called to generate and update the output vtkDataSetAttributes.

These match corresponding API on vtkDataSetAttributes and can be called via the output vtkDataSetAttributes instance instead as well.

## ◆ CopyData() [2/2]

void vtkDataSetAttributesFieldList::CopyData | ( | int | inputIndex,
|  | vtkDataSetAttributes * | input,
|  | vtkIdType | inputStart,
|  | vtkIdType | numValues,
|  | vtkDataSetAttributes * | output,
|  | vtkIdType | outStart
| ) |  | const

These methods can called to generate and update the output vtkDataSetAttributes.

These match corresponding API on vtkDataSetAttributes and can be called via the output vtkDataSetAttributes instance instead as well.

## ◆ InterpolatePoint()

void vtkDataSetAttributesFieldList::InterpolatePoint | ( | int | inputIndex,
|  | vtkDataSetAttributes * | input,
|  | vtkIdList * | inputIds,
|  | double * | weights,
|  | vtkDataSetAttributes * | output,
|  | vtkIdType | toId
| ) |  | const

These methods can called to generate and update the output vtkDataSetAttributes.

These match corresponding API on vtkDataSetAttributes and can be called via the output vtkDataSetAttributes instance instead as well.

## ◆ TransformData()

void vtkDataSetAttributesFieldList::TransformData | ( | int | inputIndex,
|  | vtkDataSetAttributes * | input,
|  | vtkDataSetAttributes * | output,
|  | std::function< void(vtkAbstractArray *, vtkAbstractArray *)> | op
| ) |  | const

Use this method to provide a custom callback function to invoke for each array in the input and corresponding array in the output.

## ◆ GetNumberOfArrays()

int vtkDataSetAttributesFieldList::GetNumberOfArrays | ( |  | ) |

This method can be used to determine the number of arrays remaining after intersection or union operations.

See also vtkFieldData::GetNumberOfArrays().

## ◆ BuildPrototype()

void vtkDataSetAttributesFieldList::BuildPrototype | ( | vtkDataSetAttributes * | protoDSA,
|  | vtkDataSetAttributes * | ordering = `nullptr`
| ) |  |

A convenience function that builds a prototype / template dataset attributes for initializing the process of attribute interpolation and copying.

The supplied protoPD should be initialized (empty), and the arrays present in this field list are instantiated and added to the prototype attributes. The typical usage is to use field list intersection (or union) operations to build up the field list, then create the prototype. Note, to retain an order of the data arrays, an optional ordering dataset attributes may be provided. (This is necessary because the vtkDataSetAttributesFieldList does not necessarily retain the original order of data arrays.)

## ◆ CreateArray()

virtual vtkSmartPointer<vtkAbstractArray> vtkDataSetAttributesFieldList::CreateArray | ( | int | type | ) | const
| protectedvirtual

Called to create an output array for the given type.

Default implementation calls `vtkAbstractArray::CreateArray()`.

The documentation for this class was generated from the following file:

- Common/DataModel/vtkDataSetAttributesFieldList.h